%{!?_initddir: %{expand: %%global _initddir %{_initrddir}}}
%if 0%{?rhel} == 5
%global _sharedstatedir %{_localstatedir}/lib
%endif

%global sslcert %{_sysconfdir}/pki/tls/certs/prosody.crt
%global sslkey %{_sysconfdir}/pki/tls/private/prosody.key

Name:           prosody
Version:        0.8.2
Release:        1%{?dist}
Summary:        Flexible communications server for Jabber/XMPP

Group:          System Environment/Daemons
License:        MIT
URL:            http://prosody.im/
Source0:        http://prosody.im/downloads/source/%{name}-%{version}.tar.gz
Source1:        %{name}.init
Patch0:         %{name}.config.patch
Patch1:         %{name}.sslcerts.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  lua-devel
BuildRequires:  libidn-devel
BuildRequires:  openssl-devel
Requires:  lua-expat
Requires:  lua-sec
Requires:  lua-filesystem


%description
Prosody is a flexible communications server for Jabber/XMPP  written in Lua.
It aims to be easy to use, and light on resources. For developers it aims
to be easy to extend and give a flexible system on which to rapidly 
develop added functionality, or prototype new protocols.


%prep
%setup -q
%patch0 -p1 -b .rpmConfig
# remove default ssl certificates
%patch1 -p1 -b .defaultSSL
#do the sed atfer patch1, to avoid a i686 build issue
sed -e 's|$(PREFIX)/lib|$(PREFIX)/%{_lib}|' -i Makefile
rm -rf certs/
# fix wrong end of line encoding
pushd doc
sed -i -e 's|\r||g' stanza.txt session.txt roster_format.txt
popd


%build
./configure \
  --with-lua='' \
  --with-lua-include=%{_includedir} \
  --prefix=%{_prefix}
make %{?_smp_mflags} CFLAGS="$RPM_OPT_FLAGS -fPIC"


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
#fix perms
%{__chmod} -x $RPM_BUILD_ROOT%{_libdir}/%{name}/%{name}.version
#avoid rpmlint unstripped-binary-or-object warnings
%{__chmod} 0755 $RPM_BUILD_ROOT%{_libdir}/%{name}/util/*.so

#install initd script
%{__mkdir} -p $RPM_BUILD_ROOT%{_initddir}
%{__install} -m755 %{SOURCE1} $RPM_BUILD_ROOT%{_initddir}/%{name}

#directories for datadir and pids
%{__mkdir} -p $RPM_BUILD_ROOT%{_sharedstatedir}/%{name}
%{__chmod} 0755 $RPM_BUILD_ROOT%{_sharedstatedir}/%{name}
%{__mkdir} -p $RPM_BUILD_ROOT%{_localstatedir}/run/%{name}


%clean
rm -rf $RPM_BUILD_ROOT


%pre
%{_sbindir}/useradd -d %{_sharedstatedir}/%{name} -r -s /sbin/nologin %{name} 2> /dev/null || :


%preun
if [ $1 = 0 ]; then
        service %{name} stop > /dev/null 2>&1 || :
        chkconfig --del %{name} || :
fi


%post
chkconfig --add %{name} || :
umask 077
if [ ! -f %{sslkey} ] ; then
%{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %{sslkey} 2> /dev/null
fi

FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

if [ ! -f %{sslcert} ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{sslkey} \
         -x509 -days 365 -set_serial $RANDOM \
         -out %{sslcert} 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi


%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING HACKERS README TODO doc/*
%{_bindir}/%{name}
%{_bindir}/%{name}ctl
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/*
%{_mandir}/man1/*.1.gz
%{_initddir}/%{name}
%dir %attr(-, %{name}, %{name}) %{_sharedstatedir}/%{name}
%dir %attr(-, %{name}, %{name}) %{_localstatedir}/run/%{name}


%changelog
* Mon Jun 20 2011 Matěj Cepl <mcepl@redhat.com> - 0.8.2-1
- New upstream release (PostgreSQL support improved)

* Fri Jun 03 2011 Matěj Cepl <mcepl@redhat.com> - 0.8.1-1
- New upstream release (Billion laughs DOS vulnerability)

* Thu Apr 14 2011 Matěj Cepl <mcepl@redhat.com> - 0.8.0-1
- New upstream release.

* Sun Jan 23 2011 Johan Cwiklinski <johan AT x-tnd DOT be> 0.7.0-4.trashy
- Redefine _initddir and _sharedstatedir marcos for EL-5

* Sat Dec 11 2010 Johan Cwiklinski <johan AT x-tnd DOT be> 0.7.0-3
- Apply ssl patch before sed on libdir; to avoid a patch context issue 
  building on i686 

* Sat Sep 11 2010 Johan Cwiklinski <johan AT x-tnd DOT be> 0.7.0-2
- No longer ships default ssl certificates, generates one at install

* Wed Jul 14 2010 Johan Cwiklinski <johan AT x-tnd DOT be> 0.7.0-1
- Update to 0.7.0

* Wed Apr 28 2010 Johan Cwiklinski <johan AT x-tnd DOT be> 0.6.2-1
- Update to 0.6.2

* Thu Dec 31 2009 Johan Cwiklinski <johan AT x-tnd DOT be> 0.6.1-1
- Initial packaging
